﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="GanttSample.aspx.cs" Inherits="GanttTestSample.GanttSample" %>

<%@ Register assembly="Syncfusion.EJ" namespace="Syncfusion.JavaScript.Models" tagprefix="ej" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Gantt Sample</title>
    <script src="Scripts/Gantt/jquery-1.10.2.min.js"></script>
    <script src="Scripts/Gantt/jquery.globalize.min.js"></script>
    <script src="Scripts/Gantt/jquery.easing.1.3.min.js"></script>
    <script src="Scripts/Gantt/jsrender.min.js"></script>
    <script src="Scripts/Gantt/ej.web.all.min.js"></script>
    <link href="Content/Gantt/ej.widgets.core.min.css" rel="stylesheet" />
    <link href="Content/Gantt/ej.theme.min.css" rel="stylesheet" />
    <style>
         #Gantt {
             width: 100%;
             height: 100%;             
         }
         html, body {
             overflow: hidden; padding:0; margin: 0;height:100%;position:static;
         }
     </style>
    
</head>
<body>
    <form id="form1" runat="server" onsubmit="return false" style="overflow: hidden; padding:0; margin: 0;height:100%;width:100%;">
        <ej:Gantt ID="Gantt" runat="server"  AllowColumnResize="true" AllowSorting="true" 
            TaskIdMapping="TaskID" TaskNameMapping="TaskName" StartDateMapping="StartDate" 
            ProgressMapping="Progress" EndDateMapping="EndDate"
            ChildMapping="SubTasks" EnableVirtualization="true" HighlightWeekends="true"  PredecessorMapping="Predecessors"
            ScheduleStartDate="02/01/2014"  ScheduleEndDate="03/14/2014"           
            ShowGridCellTooltip="true" TreeColumnIndex="0"
            IncludeWeekend="false" EnableContextMenu="true" Load="Load" RowSelected="rowselected">            
                      
            <EditSettings AllowEditing="true" AllowAdding="true" AllowDeleting="true" EditMode="cellEditing" />
        </ej:Gantt>
        <script>
            function Load(args) {
                var columns = this.getColumns(),
                    length = columns.length;
                for (var i = (length-1); i >= 0 ; i--) {
                    if (columns[i].field == "taskId" || columns[i].field == "startDate" || columns[i].field == "status") {
                        columns.splice(i, 1);
                    }
                }
            
            }

            function rowselected(args) {
                
                var selectedRowItem = args,
                    length = selectedRowItem.data.predecessor.length,

                    //Obtaining the Gantt object
                    ganttObject = $("#Gantt").data("ejGantt"),

                    scheduleStartDate = ganttObject.model.scheduleStartDate, scheduleEndDate = ganttObject.model.scheduleEndDate;
                    
                //check if the record has more than one predecessor
                for (var i = 0; i < length; i++) {

                    //Extract the predecessor record
                    var predecessorRecord = ganttObject.model.ganttRecords[parseInt(args.data.predecessor[i].from) - 1];


                    if (args.data.item["TaskID"] != predecessorRecord.item["TaskID"]) {

                        //Update the dates with predecessor's start date and end date
                        if (new Date(scheduleStartDate).getTime() != new Date(predecessorRecord.item["StartDate"]).getTime()) {
                            scheduleStartDate = predecessorRecord.item["StartDate"];
                        }
                        if (new Date(scheduleEndDate).getTime() != new Date(predecessorRecord.item["EndDate"]).getTime()) {
                            scheduleEndDate = predecessorRecord.item["EndDate"];
                        }
                    }
                   
                }

                //Update the Gantt schedule startdate
                ganttObject.model.scheduleStartDate = scheduleStartDate;

                //UPdate the Gantt schedule enddate
                ganttObject.model.scheduleEndDate = scheduleEndDate;

                //Rerender Gantt schedule with new dates
                $("#Gantt").ejGantt("updateScheduleDates", scheduleStartDate,scheduleEndDate);
            }

        </script>
    </form>
</body>
</html>
